import { ClassData, MethodData } from 'lib-reflect';
import { IAfterActivation } from './interfaces/i.after.activation';
import { IBeforeActivation } from './interfaces/i.before.activation';
import { IActivation, IContext } from './interfaces/i.context';
export declare type ErrorCallback = (interceptor: IBeforeActivation | IAfterActivation, err: any) => void;
export declare class Activation implements IActivation {
    class: ClassData;
    method: MethodData;
    beforeActivation: IBeforeActivation[];
    afterActivation: IAfterActivation[];
    data: Record<string, any>;
    execute(ctx: IContext, onError?: ErrorCallback): Promise<IContext>;
    removeBeforeActivation(activation: IBeforeActivation, context: IContext): void;
    removeAfterActivation(activation: IAfterActivation, context: IContext): void;
}
