"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../utils");
class ExecuteActivation {
    async before(context) {
        const activationInfo = context.getActivation();
        const container = context.getContainer();
        const targetInstance = container.get(activationInfo.class.target);
        const result = targetInstance[activationInfo.method.name].apply(targetInstance, context.getArguments());
        if (utils_1.isAwaitable(result)) {
            const promiseResult = await result;
            return context.setSuccess(promiseResult);
        }
        return context.setSuccess(result);
    }
}
exports.ExecuteActivation = ExecuteActivation;
//# sourceMappingURL=execute.js.map