"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../utils");
class ExecuteActivationStatic {
    async before(context) {
        const activationInfo = context.getActivation();
        const target = activationInfo.class.target;
        const result = target[activationInfo.method.name].apply(null, context.getArguments());
        if (utils_1.isAwaitable(result)) {
            const promiseResult = await result;
            return context.setSuccess(promiseResult);
        }
        return context.setSuccess(result);
    }
}
exports.ExecuteActivationStatic = ExecuteActivationStatic;
//# sourceMappingURL=execute.static.js.map