"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lib_reflect_1 = require("lib-reflect");
const lodash_1 = require("lodash");
const interceptor_data_1 = require("../interceptor.data");
function UseActivation(activation, type, metadata) {
    return lib_reflect_1.AnyDecoratorFactory((classData, methodOrProp, arg2) => {
        const data = new interceptor_data_1.InterceptorData();
        data.target = activation;
        if (!lodash_1.isNil(type)) {
            data.type = type;
        }
        data.metadata = metadata;
        // Add the information on attributes data
        const decoratorType = lib_reflect_1.GetDecoratorType(classData, methodOrProp, arg2);
        switch (decoratorType) {
            case lib_reflect_1.DecoratorType.Class:
                classData.attributesData.push(data);
                break;
            case lib_reflect_1.DecoratorType.Method:
                methodOrProp.attributesData.push(data);
                break;
            default:
                throw new Error('Invalid usage of the UseActivation decorator.');
        }
    });
}
exports.UseActivation = UseActivation;
function UseBefore(activation, metadata) {
    return UseActivation(activation, interceptor_data_1.InterceptorType.Before, metadata);
}
exports.UseBefore = UseBefore;
function UseAfter(activation, metadata) {
    return UseActivation(activation, interceptor_data_1.InterceptorType.After, metadata);
}
exports.UseAfter = UseAfter;
//# sourceMappingURL=use.activation.js.map