import { Container } from 'inversify';
import { IActivation, IContext } from './interfaces/i.context';
export declare class DefaultContext implements IContext {
    private readonly _container;
    private readonly _activation;
    private _data;
    private _args;
    private _success;
    error: any;
    payload: any;
    beforeActivationIdx: number;
    beforeActivationLength: number;
    constructor(_container: Container, _activation: IActivation);
    setSuccess(payload: any): boolean;
    setError(error: any): boolean;
    isError(): boolean;
    isSuccess(): boolean;
    execute(): Promise<any>;
    getActivation(): IActivation;
    getContainer(): Container;
    getArguments(): any[];
    setArguments(args: any[]): void;
    getData<T>(key: string, defaultVal?: T): T;
    setData(key: string, data: any): void;
}
