"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class DefaultContext {
    constructor(_container, _activation) {
        this._container = _container;
        this._activation = _activation;
        // IActivation
        this.beforeActivationIdx = 0;
        this.beforeActivationLength = 0;
        this.error = null;
        this.payload = null;
        this._success = true;
        this._data = null;
        this._args = null;
    }
    setSuccess(payload) {
        this._success = true;
        this.payload = payload;
        this.error = null;
        return true;
    }
    setError(error) {
        this._success = false;
        this.error = error;
        this.payload = null;
        return false;
    }
    isError() {
        return !this.isSuccess();
    }
    isSuccess() {
        return this._success === true;
    }
    execute() {
        return this._activation.execute(this);
    }
    getActivation() {
        return this._activation;
    }
    getContainer() {
        return this._container;
    }
    getArguments() {
        return this._args;
    }
    setArguments(args) {
        this._args = args;
    }
    getData(key, defaultVal) {
        if (this._data === null) {
            return defaultVal;
        }
        const val = this._data[key];
        return val === undefined ? defaultVal : val;
    }
    setData(key, data) {
        if (this._data === null) {
            this._data = {};
        }
        this._data[key] = data;
    }
}
exports.DefaultContext = DefaultContext;
//# sourceMappingURL=context.js.map