import { Container } from 'inversify';
import { ClassData, MethodData } from 'lib-reflect';
import { IAfterActivation } from './i.after.activation';
import { IBeforeActivation } from './i.before.activation';
export declare type ActivationErrorCallback = (interceptor: IBeforeActivation | IAfterActivation, err: any) => void;
export interface IActivation {
    class: ClassData;
    method: MethodData;
    beforeActivation: IBeforeActivation[];
    afterActivation: IAfterActivation[];
    execute(ctx: IContext, onError?: ActivationErrorCallback): Promise<any>;
    removeBeforeActivation(activation: IBeforeActivation, context: IContext): void;
    removeAfterActivation(activation: IAfterActivation, context: IContext): void;
    data: Record<string, any>;
}
export interface IContext {
    error: any;
    payload: any;
    beforeActivationIdx: number;
    beforeActivationLength: number;
    execute(): Promise<any>;
    getActivation(): IActivation;
    setSuccess(payload: any): boolean;
    setError(error: any): boolean;
    isError(): boolean;
    isSuccess(): boolean;
    getContainer(): Container;
    getArguments(): any[];
    setArguments(args: any[]): void;
    getData<T>(key: string, defaultVal?: T): T;
    setData(key: string, data: any): void;
}
